Hooks:PostHook( HUDAssaultCorner, "init", "nephud_kill_panel_hud", function(self, data)
	self._total_killed_in_session = 0

	local icons_panel = self._custom_hud_panel:child("icons_panel")
	local cuffed_panel = icons_panel:child("cuffed_panel")
	local panel_w, panel_h = 44 * self._scale, 38 * self._scale
	local is_level_ghostable = managers.job:is_level_ghostable(managers.job:current_level_id()) and managers.groupai and managers.groupai:state():whisper_mode()
	local highlight_texture = "guis/textures/VoidUI/hud_highlights"

	local kills_panel = icons_panel:panel({
		name = "kills_panel",
		w = panel_w,
		h = panel_h,
		alpha = 1
	})
	
	kills_panel:set_right(cuffed_panel:left()) 

	local kills_background = kills_panel:bitmap({
		name = "kills_background",
		texture = highlight_texture,
		texture_rect = {0,316,171,150},
		layer = 1,
		w = panel_w,
		h = panel_h,
		color = Color.black
	})

	local kills_border = kills_panel:bitmap({
		name = "kills_border",
		texture = highlight_texture,
		texture_rect = {172,316,171,150},
		layer = 2,
		w = panel_w,
		h = panel_h,
	})

	local num_kills = kills_panel:text({
		name = "num_kills",
		text = "0",
		valign = "center",
		vertical = "bottom",
		align = "right",
		w = panel_w / 1.2,
		h = panel_h,
		layer = 3,
		x = 0,
		y = 0,
		color = Color.white,
		font = "fonts/font_medium_shadow_mf",
		font_size = panel_h / 2
	})

	local kills_icon = kills_panel:bitmap({
		name = "kills_icon",
		texture = "guis/textures/pd2/crimenet_skull",
		valign = "top",
		alpha = 0.6,
		layer = 2,
		w = panel_w / 2.2,
		h = panel_h / 1.8,
		x = 0,
		y = 0
	})

	kills_icon:set_center(kills_border:center())
end)

function HUDAssaultCorner:_offset_hostage(is_offseted, hostage_panel, big_logo)
	local TOTAL_T = 0.18
	local icons_panel = self._custom_hud_panel:child("icons_panel")
	local wave_panel = self._custom_hud_panel:child("wave_panel")
	local cuffed_panel = icons_panel:child("cuffed_panel")
	local pagers_panel = icons_panel:child("pagers_panel")
	local kills_panel = icons_panel:child("kills_panel")
	local panel_right = icons_panel:right()
	local panel_y = icons_panel:y()
	local t = 0
	while TOTAL_T > t do
		local dt = coroutine.yield()
		t = math.min(t + dt, TOTAL_T)
		local lerp = t / TOTAL_T
		if is_offseted then 
			icons_panel:set_alpha(math.lerp(1,0,lerp))
			if wave_panel then wave_panel:set_alpha(math.lerp(1,0,lerp)) end
		else
			icons_panel:set_right(math.lerp(panel_right, self._custom_hud_panel:w(),lerp))
			icons_panel:set_y(math.lerp(panel_y, 0, lerp))
			hostage_panel:set_y(0)
			cuffed_panel:set_y(0)
			pagers_panel:set_y(0)
			kills_panel:set_y(0)
			if wave_panel then 
				wave_panel:set_right(math.lerp(self._custom_hud_panel:w() - 75 * self._scale, self._custom_hud_panel:w() - 5 * self._scale,lerp))
				wave_panel:set_y(math.lerp(47 * self._scale, 0, lerp))
			end
		end
		if self._start_assault_after_hostage_offset and lerp > 0.4 then
			self._start_assault_after_hostage_offset = nil
			self:start_assault_callback()
		end
	end	
	if is_offseted then
		if big_logo then wait(0.6) end
		TOTAL_T = 0.3
		t = 0
		icons_panel:set_right(big_logo and self._custom_hud_panel:w() - 70 * self._scale or self._custom_hud_panel:w() - 2 * self._scale)
		icons_panel:set_y(big_logo and 47 * self._scale or 32 * self._scale)
		hostage_panel:set_y(-hostage_panel:h())
		cuffed_panel:set_y(-cuffed_panel:h() * 2 * self._scale)
		pagers_panel:set_y(-pagers_panel:h() * 2 * self._scale)
		kills_panel:set_y(-kills_panel:h() * 2 * self._scale)
		if wave_panel then 
			wave_panel:set_right(big_logo and self._custom_hud_panel:w() - 75 * self._scale or self._custom_hud_panel:w() - 7 * self._scale)
			wave_panel:set_y(big_logo and 47 * self._scale or 32 * self._scale)
		end
		icons_panel:set_alpha(1)
		while TOTAL_T > t do
			local dt = coroutine.yield()
			t = math.min(t + dt, TOTAL_T)
			local lerp = t / TOTAL_T
			hostage_panel:set_y(math.lerp(-hostage_panel:h(),0,lerp))
			cuffed_panel:set_y(math.lerp(-cuffed_panel:h() * 2,0,lerp))
			pagers_panel:set_y(math.lerp(-pagers_panel:h() * 2,0,lerp))
			kills_panel:set_y(math.lerp(-kills_panel:h() * 2,0,lerp))
			if wave_panel then wave_panel:set_alpha(math.lerp(0,1,lerp)) end
		end
	end
	icons_panel:set_alpha(1)
	self:whisper_mode_changed()
	if self._start_assault_after_hostage_offset then
		self._start_assault_after_hostage_offset = nil
		self:start_assault_callback()
	end
end